'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _node = require('./node');

var _node2 = _interopRequireDefault(_node);

var Container = (function (_Node) {
    function Container(opts) {
        _classCallCheck(this, Container);

        _get(Object.getPrototypeOf(Container.prototype), 'constructor', this).call(this, opts);
        if (!this.nodes) {
            this.nodes = [];
        }
    }

    _inherits(Container, _Node);

    _createClass(Container, [{
        key: 'append',
        value: function append(selector) {
            selector.parent = this;
            this.nodes.push(selector);
            return this;
        }
    }, {
        key: 'prepend',
        value: function prepend(selector) {
            selector.parent = this;
            this.nodes.unshift(selector);
            return this;
        }
    }, {
        key: 'at',
        value: function at(index) {
            return this.nodes[index];
        }
    }, {
        key: 'index',
        value: function index(child) {
            if (typeof child === 'number') {
                return child;
            }
            return this.nodes.indexOf(child);
        }
    }, {
        key: 'first',
        get: function () {
            return this.at(0);
        }
    }, {
        key: 'last',
        get: function () {
            return this.at(this.nodes.length - 1);
        }
    }, {
        key: 'remove',
        value: function remove(child) {
            child = this.index(child);
            this.nodes[child].parent = undefined;
            this.nodes.splice(child, 1);

            return this;
        }
    }, {
        key: 'removeAll',
        value: function removeAll() {
            var child = undefined;
            while (child = this.index(0)) {
                child.removeSelf();
            }
            return this;
        }
    }, {
        key: 'empty',
        value: function empty() {
            return this.removeAll();
        }
    }, {
        key: 'each',
        value: function each(callback) {
            this.nodes.forEach(callback);
            return this;
        }
    }, {
        key: 'every',
        value: function every(callback) {
            return this.nodes.every(callback);
        }
    }, {
        key: 'some',
        value: function some(callback) {
            return this.nodes.some(callback);
        }
    }, {
        key: 'toString',
        value: function toString() {
            return [this.spaces.before, this.nodes.map(String).join(''), this.spaces.after].join('');
        }
    }]);

    return Container;
})(_node2['default']);

exports['default'] = Container;
module.exports = exports['default'];